/* Return the size of a malloc'd block.
Copyright (C) 1996 Free Software Foundation, Inc.
This file is part of the GNU C Library.

The GNU C Library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public License as
published by the Free Software Foundation; either version 2 of the
License, or (at your option) any later version.

The GNU C Library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with the GNU C Library; see the file COPYING.LIB.  If
not, write to the Free Software Foundation, Inc., 675 Mass Ave,
Cambridge, MA 02139, USA.  */

#define _MALLOC_INTERNAL
#include <libc-lock.h>
#include <malloc.h>

/* Locking.  */
__libc_lock_define (extern, __libc_malloc_lock)

__malloc_size_t
malloc_usable_size (__ptr_t ptr)
{
  __malloc_size_t block = BLOCK (ptr);
  __malloc_size_t result;

  __libc_lock_lock (__libc_malloc_lock);

  if (_heapinfo[block].busy.type == 0)
    result = _heapinfo[block].busy.info.size;
  else
    result = 1 << _heapinfo[block].busy.type;

  __libc_lock_unlock (__libc_malloc_lock);

  return result;
}
